package com.turaz.pricer.instrumentation;

/**
 * This is the Pricer that we wish to instrument. This is NOT REAL PRICING. The only purpose is to
 * provide a fake spray of methods to examine how easy it is to pull out values. 
 * -Have local variables in several different methods whose values we wish to track. 
 * 
 */
public class DummyPricer {

    public double price(Trade trade, double input1, char input2) {
        double npv = 0.0;

        for (int i = 0; i < 10; i++) {
            npv += computeSomething(trade, input1);
        }

        return npv;
    }

    private double computeSomething(Trade trade, double input1) {
        double a = 100.34;
        // @Track
        double PI = 3.1415;
        double b = 345.6;
        double rand = Math.random();
        double cf_price = rand * PI / (a + doSomethingElse(a));
        cf_price = Math.pow(cf_price, 2);
        double ret_price = cf_price * b;
        return ret_price;
    }

    private double doSomethingElse(double x) {
        return x * 2;
    }

    public static void aMethod() {
        System.out.println("In a method");
    }
}

class Trade {
    private int    id;
    private char   freq;
    private double rate;

    public int getId() {
        return id;
    }

    public char getFreq() {
        return freq;
    }

    public double getRate() {
        return rate;
    }

    @Override
    public String toString() {
        return "Trade [id=" + id + ", freq=" + freq + ", rate=" + rate + "]";
    }

}
