import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Map;

import org.junit.Assert;
import org.junit.Test;

public class TestInstrumentationScripts {

    @Test
    public void testScriptRulesCompile() throws IOException {
        // GOAL: I want to check that all scripts in the instrumentationScripts folder compile
        // If one does not then I want to be notified which one fails and see the error message
        // associated with that.
        // There is a byteman java class called TestScript. This can check rule compilation
        // unfortunately it is currently intended to be run from command line so it needs a bit of
        // wrapping
        // before it is useful

        List<File> scripts = ScriptDiscovery.findScriptsForThisProject();
        for (File scriptFile : scripts) {
            System.out.println("Test script compilation for " + scriptFile.getName());
            Map<String, CompilationResult> ruleCompilationResults = ScriptCompileToolWrapper
                .compileScript(scriptFile);

            for (String ruleName : ruleCompilationResults.keySet()) {
                CompilationResult compileResult = ruleCompilationResults.get(ruleName);
                String passFail = compileResult.isRuleCompiledOk() ? "PASSED" : "FAILED";
                String shortMsg = "Script compilation " + passFail + " for SCRIPT=" +
                    scriptFile.getName() + ", RULE=" + ruleName;
                String longMsg = shortMsg + compileResult;
                if (compileResult.isRuleCompiledOk()) {
                    System.out.println(shortMsg);
                } else {
                    System.out.println(longMsg);
                }
                Assert.assertTrue(longMsg + ":" + compileResult, compileResult.isRuleCompiledOk());
            }
        }

    }
}
